part of LanguageTools;

class ParserTool {
    LexerTool lexer;
    Token token;

    List<Token> tokens = [];
    int tokenspos = 0;
    Position endPosition;

    parse(String input) {
        lexer.setInput(input);
        token = lexer.nextToken();;
        return parseStart();
    }

    parseStart() {}

    // methods
    Token next() {
        Token t = token;
        token = lexer.nextToken();
        return t;
    }

    Token requireNext(String type) {
        if (token.type != type) {
            fail(expected: type);
        }
        return next();
    }

    Token look() {
        return tokens[tokenspos];
    }

    void consume(String type) {
        if(token.type != type) {
            fail(expected: type);
        }
        next();
    }

    // erroring
    dynamic fail({String tok, String expected, String message}) {
        if (tok == null)
            tok = token.toString();
        if (message == null)
            if (expected != null)
                message = "Expected $expected but found $tok";
            else
                message = "Unexpected token $tok";
        throw message;
    }
}