part of LanguageTools;

// Object describing a matched token
class Token {
    Map<String, dynamic> _ = {
        'type': null,
        'value': null,
        'location': {}
    };

    Token([String type = 'EOF']) {
        _['type'] = type;
    }

    String get type => _['type'];
    String get value => _['value'];

    bool get isNull => _['type'] == null || _['type'] == 'EOF';

    Token set(String key, dynamic value) {
        _[key] = value;
        return this;
    }

    dynamic get(String key) => _[key];

    Map<String, dynamic> getAll() => _;

    Token setStart(Position value) {
        _['location']['start'] = value;
        return this;
    }

    Token setEnd(Position value) {
        _['location']['end'] = value;
        return this;
    }

    Position getStart() => _['location']['start'];

    Position getEnd() => _['location']['end'];

    String toString() => '@token(' + this['type'] + (this['value'] != null ? ',' + this['value'] : '') + ')';

    // token operators
    dynamic operator [](String key) => _[key];

    dynamic operator []=(String key, dynamic value) {
        _[key] = value;
        return value;
    }
}